
var passwordLength = 5;

displayView = function(){
// the code required to display a view
  if(window.localStorage.getItem('token')){
    var html_content = document.getElementById('Profilewrapper').innerHTML;
    document.getElementById('content').innerHTML = html_content;
    loadProfileDetail();
    getMessages();
  }else {
    var html_content = document.getElementById('Welcomewrapper').innerHTML;
    document.getElementById('content').innerHTML = html_content;
  }
};

window.onload = function(){
//code that is executed as the page is loaded.
//You shall put your own custom code here.
//window.alert() is not allowed to be used in your implementation.
//

displayView();
//alert(window.localStorage.getItem('token'));
};

loadProfileDetail = function(){

  var response = serverstub.getUserDataByToken(window.localStorage.getItem('token'));

  document.getElementById('first-name').innerHTML = response.data.firstname;
  document.getElementById('last-name').innerHTML = response.data.familyname;
  document.getElementById('user-email').innerHTML = response.data.email;
  document.getElementById('user-gender').innerHTML = response.data.gender;
  document.getElementById('user-city').innerHTML = response.data.city;
  document.getElementById('user-country').innerHTML = response.data.country;
}

login = function(){
  var email = document.forms["form-login"].email.value;
  var pass = document.forms["form-login"].password.value;
  var response = serverstub.signIn(email, pass);

  if(response.success == true){
    window.localStorage.setItem('token', response.data);
    displayView();
  }else {
      document.getElementById('error-login').innerHTML = response.message;
  }

}

signup = function(){
  var email = document.forms["form-data"].email.value;
  var fname = document.forms["form-data"].fname.value;
  var familyname = document.forms["form-data"].familyname.value;
  var gender = document.forms["form-data"].gender.value;
  var city = document.forms["form-data"].city.value;
  var country = document.forms["form-data"].country.value;

  var pass = document.forms["form-data"].password.value;
  var rePass = document.forms["form-data"].repassword.value;
  var message = '';
  if(pass!=rePass){
    message = "Password does't match!";
  }else{
    if(pass.length < passwordLength){
        message = "Password should be at-least "+ passwordLength +" characters!";
    }else{
      var newSignUp = {
        email: email,
        password: pass,
        firstname: fname,
        familyname: familyname,
        gender: gender,
        city: city,
        country: country
      }

      var response = serverstub.signUp(newSignUp);

      if(response.success == true){
        message = "New User Added successfully!";
      }else {
          message = response.message;
      }
    }
  }
  document.getElementById('error-signup').innerHTML = message;
  setTimeout(function(){// wait for 2
           //location.reload(); // then reload the page.
      }, 2000);
}


openTabs = function(evt, tabName) {
  var i, content, tablinks;
  content = document.getElementsByClassName("tab-content");
  for (i = 0; i < content.length; i++) {
    content[i].style.display = "none";
  }

  tablinks = document.getElementsByClassName("tab-links");
  for (i = 0; i < tablinks.length; i++) {
    tablinks[i].className = tablinks[i].className.replace(" active", "");
  }

  document.getElementById(tabName).style.display = "block";
  evt.currentTarget.className += " active";
}

logout = function (){
  var response = serverstub.signOut(window.localStorage.getItem('token'));
  if(response.success == true){
    window.localStorage.setItem('token', '');
    displayView();
  }
}

refresh = function(){
  setTimeout(function(){// wait for 2
           location.reload(); // then reload the page.
      }, 2000);
}

changePassword = function(){
  var oldpass = document.forms["form-changePass"].oldPass.value;
  var pass = document.forms["form-changePass"].NewPass.value;
  var rePass = document.forms["form-changePass"].reNewPass.value;
  var message = '';
  if(pass!=rePass){
    message = "Password does't match!";
  }else{
    if(pass.length < passwordLength){
        message = "Password should be at-least "+ passwordLength +" characters!";
    }else{
      if(oldpass == pass){
        message = "Password should be different from previous!";
      }else{
        var response = serverstub.changePassword(window.localStorage.getItem('token'), oldpass, pass);
        if(response.success == true){
          message = response.message;
          refresh();
        }else {
          message = response.message;
        }
      }
    }
    document.getElementById('error-changePass').innerHTML = message;
  }
}

sendMessages = function(){
  var message = "";
  var content = document.forms["form-message"].message.value;
  if(content.length >= 1){
    var response = serverstub.getUserDataByToken(window.localStorage.getItem('token'));
    var toEmail = response.data.emaiil;
    var response = serverstub.postMessage(window.localStorage.getItem('token'), content, toEmail);
    alert(response.success);
    if(response.success == true){
      message = response.message;
    }else {
      message = response.message;
    }
  }else{
    message = "Write something!";
  }

  document.getElementById('msgSent').innerHTML = message;
  document.getElementById("Message").value = "";
  getMessages();
}

getMessages = function(){
  var message = "";
  var response = serverstub.getUserMessagesByToken(window.localStorage.getItem('token'));
  if(response.success == true){
    response.data.forEach(function(item) {
        message += "by:" + item['writer'] + "\nmsg:" + item['content'] +"\n\n";
    });
  }else {
    message = response.message;
  }
  document.getElementById("getAllMessages").innerHTML = message;
}

searchProfile = function(){
  var email = document.forms["form-search"].searchEmail.value;


  loadProfileDetailByEmail(email);
  getMessagesByEmail(email);
}

loadProfileDetailByEmail = function(email){
  var response = serverstub.getUserDataByEmail(window.localStorage.getItem('token'), email);
  if(response.success){
    document.getElementById('sfirst-name').innerHTML = response.data.firstname;
    document.getElementById('slast-name').innerHTML = response.data.familyname;
    document.getElementById('suser-email').innerHTML = response.data.email;
    document.getElementById('suser-gender').innerHTML = response.data.gender;
    document.getElementById('suser-city').innerHTML = response.data.city;
    document.getElementById('suser-country').innerHTML = response.data.country;
  }
}

getMessagesByEmail = function(email){
  var message = "";
  var email = document.forms["form-search"].searchEmail.value;
  var response = serverstub.getUserMessagesByEmail(window.localStorage.getItem('token'), email);
  if(response.success == true){
    if(response.data.length > 1){
      response.data.forEach(function(item) {
          message += "by:" + item['writer'] + "\nmsg:" + item['content'] +"\n\n";
      });
    }else{
      message = "User have no messages!";
    }
  }else {
    message = response.message;
  }

  document.getElementById("getAllOthersMessages").innerHTML = message;
}

sendMessageOther = function(){
  var content = document.forms["form-Othermessage"].othermessage.value;
  if(content.length >= 1){
    var toEmail = document.forms["form-search"].searchEmail.value;
    var response = serverstub.postMessage(window.localStorage.getItem('token'), content, toEmail);
    if(response.success == true){
      message = response.message;
    }else {
      message = response.message;
    }
  }else{
    message = "Write something!";
  }

  document.getElementById('msgSentOther').innerHTML = message;
  document.getElementById("OtherMessage").value = "";
  getMessagesByEmail(toEmail);
}
