import sqlite3
import random
import string


def find_user(email):
    con = sqlite3.connect('database.db')
    db = con.cursor()
    db.execute("SELECT * FROM users WHERE email=?;",(email,))
    dbResult = db.fetchone()
    user = None;
    if(dbResult != None):
        user = {"email":None,"password":None,"firstname":None,"familyname":None,"gender":None,"city":None,"country":None}
        i = 0
        for key in user:
            user[key] = dbResult[i]
            i += 1
    db.close()
    con.close()
    return user


# Creates a token, inserts it in the users table and then returns the token
def new_token(email):
    con = sqlite3.connect('database.db')
    db = con.cursor()
    token = ""
    tokenCreated = False

    # Checks if user is already on the logged in table. If so return the token associated with the email
    db.execute("SELECT * FROM logged_in WHERE email=?;",(email,))
    result = db.fetchone()
    if(result != None):
        token = result[1]
        tokenCreated = True

    # If user wasn't already loggen in. generate a random token.
    while(tokenCreated == False):
        token=""    # Reset token every iteration
        characterAlternatives = string.ascii_letters # get lowercase and uppercase letters
        characterAlternatives += "0123456789" # adding digits as alternatives
        for i in range(0,20):
            # Adds a random character alternative to the token
            token += characterAlternatives[random.randint(0,len(characterAlternatives)-1)]

        # Check if generated token already exist, if not, exit the loop
        if(get_online_user(token) == None):
            db.execute("INSERT INTO logged_in VALUES(?,?);",(email,token))
            con.commit()
            tokenCreated=False;
            break;


    db.close()
    con.close()
    return token

def clear_token(token):
    con = sqlite3.connect('database.db')
    db = con.cursor()
    try:
        db.execute("DELETE FROM logged_in WHERE token=?",(token,))
        con.commit()
        db.close()
        con.close()
        return True
    except:
        db.close()
        con.close()
        return False

def get_online_user(token):
    con = sqlite3.connect('database.db')
    db = con.cursor()
    db.execute("SELECT email FROM logged_in WHERE token=?;",(token,))
    dbResult = db.fetchone()
    db.close()
    con.close()
    if(dbResult != None):
        return dbResult[0]
    else:
        return None

def new_user(email,password,firstname,familyname,gender,city,country):
    con = sqlite3.connect('database.db')
    db = con.cursor()

    try:
        db.execute("INSERT INTO users VALUES(?,?,?,?,?,?,?);",(email,password,firstname,familyname,gender,city,country))
        con.commit()
        db.close()
        con.close()
        return True
    except:
        db.close()
        con.close()
        return False

def new_password(email,password):
    con = sqlite3.connect('database.db')
    db = con.cursor()

    try:
        db.execute("UPDATE users SET password=? WHERE email=?;",(password,email))
        con.commit()
        db.close()
        con.close()
        return True
    except:
        db.close()
        con.close()
        return False
    return

def retrieve_messages(email):
    con = sqlite3.connect('database.db')
    db = con.cursor()
    db.execute("SELECT * FROM posts WHERE toEmail=?;",(email,))
    dbResult = db.fetchall()
    messages = []
    for i in range(0,len(dbResult)):
        messages.append({'writer':dbResult[i][1],'content':dbResult[i][2]})
    db.close()
    con.close()
    return messages


def create_post(toEmail,fromEmail,message):
    con = sqlite3.connect('database.db')
    db = con.cursor()
    try:
        db.execute("INSERT INTO posts VALUES(?,?,?);",(toEmail,fromEmail,message))
        con.commit()
        db.close()
        con.close()
        return True
    except:
        db.close()
        con.close()
        return False
